﻿using Connected.Models;
using Microsoft.AspNetCore.Components;

namespace Connected.Components;
public partial class Radio : InputBase
{
	[CascadingParameter]
	public RadioGroup? ParentRadioGroup { get; set; }

	private bool _checked { get; set; }

	[Parameter]
	public bool? Checked
	{
		get => _checked;
		set => _checked = (bool)value;
	}

	[Parameter, EditorRequired]
	public string Id { get; set; }

	[Parameter]
	public EventCallback<bool> CheckedChanged { get; set; }

	public async Task OnChange()
	{
		Checked = !Checked;
		CheckedChanged.InvokeAsync((bool)Checked);
	}

	protected override async Task OnInitializedAsync()
	{
		await base.OnInitializedAsync();
		if (ParentRadioGroup.Disabled) Disabled = true;
		if (!InputAttributes.ContainsKey("disabled"))
			InputAttributes.Add("disabled", Disabled);
	}
}
